import router from './router'
import store from './store'
import {Message,MessageBox } from 'element-ui'
import NProgress from 'nprogress'
import 'nprogress/nprogress.css'
import {getToken} from '@/benyun/utils/auth'
import {isRelogin} from '@/benyun/utils/request'
// import {getQueryString} from "@/benyun/utils/benyuntech";
// import {getQueryObject} from '@/benyun/utils'

NProgress.configure({ showSpinner: false })

// const whiteList = ['/login', '/demo', '/auth-redirect', '/bind', '/register']

const infoHandle = (to:any, next:any) => {
  isRelogin.show = true
  // 判断当前用户是否已拉取完user_info信息
  store.dispatch('GetInfo').then(() => {
    isRelogin.show = false
    store.dispatch('GenerateRoutes').then(accessRoutes => {
      // 根据roles权限生成可访问的路由表
      for(const item of accessRoutes){
        router.addRoute(item)
      }
      // router.addRoutes(accessRoutes) // 动态添加可访问路由表
      next({ ...to, replace: true }) // hack方法 确保addRoutes已完成
    })
  }).catch(err => {
    MessageBox.alert(err, '提示', {
      confirmButtonText: '确定',
      callback: () => {
        store.dispatch('LogOut').then(() => {})
      }
    });
    
  })
}

router.beforeEach((to:any, from:any, next:any) => {
  NProgress.start()
  // let params = getQueryObject();
  // const ticket = params.ticket;
  // const ssoToken = params.ssoToken;
  const token  = getToken();
  if (token) {
    to.meta.title && store.dispatch('settings/setTitle', to.meta.title)
    /* has token*/
    // if (to.path === '/login') {
    //   next({ path: '/' })
    //   NProgress.done()
    // } else {
      if (store.getters.roles.length === 0) {
        infoHandle(to,next)
      } else {
        next()
      }
    // }
  } else {
    const redirect = location.origin
    location.href = `${process.env.VUE_APP_LOGIN_URL}?&redirect=${encodeURIComponent(redirect)}`
    // if(!ticket && !ssoToken){
    //   const redirect = location.origin
    //   location.href = `${process.env.VUE_APP_LOGIN_URL}?&redirect=${encodeURIComponent(redirect)}`
    // }else{
    //   const url = ticket ? '/sso/doLoginByTicket' : '/sso/doLoginByToken'
    //   let data:any = {}
    //   if(ticket) {
    //     data.ticket = ticket
    //   }
    //   if(ssoToken) {
    //     data.token = ssoToken
    //   }
    //   store.dispatch('GetToken',{
    //     url,data
    //   }).then(() => {
    //     infoHandle(to,next)
    //     // location.href = '/index';
    //   }).catch((err:any) => {
    //     let msg = '未知错误，请联系管理员！'
    //     if(err && err.msg) {
    //      msg = err.msg
    //       // Message.error(err.msg);
    //     }
    //     MessageBox.alert(msg, '提示', {
    //       confirmButtonText: '确定',
    //       callback: () => {
    //         const redirect = location.origin
    //         location.href = `${process.env.VUE_APP_LOGIN_URL}?&redirect=${encodeURIComponent(redirect)}`
    //       }
    //     });
        
    //   })
    //   // next()
    // }
    

    // 没有token
    // if (whiteList.indexOf(to.path) !== -1) {
    //   // 在免登录白名单，直接进入
    //   next()
    // } else {
      
    //   next(`/login?redirect=${to.fullPath}`) // 否则全部重定向到登录页
    //   NProgress.done()
    // }
  }
})

router.afterEach(() => {
  NProgress.done()
})

